<div class="flex flex-col h-screen">
  <mat-card class="m-4">
    <mat-card-header class="m-2">
      <mat-card-title>
        <div class="flex">
          <button class="secondary-icon mr-3" (click)="back()"><mat-icon>keyboard_backspace</mat-icon></button>
        {{ name || "New OAuth 2.0 Provider" }}
        </div></mat-card-title>
    </mat-card-header>
    <mat-card-content class="flex flex-col">
      <form [formGroup]="providerForm">
        <mat-form-field class="w-full">
          <mat-label>Name</mat-label>
          <input matInput  formControlName="name" mat-raised-button required>
          <mat-checkbox formControlName="isDisabled" matSuffix class="client-checkboxes">Disable Oauth</mat-checkbox>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Authorization Server URL</mat-label>
          <input matInput  formControlName="authServerURL" mat-raised-button
            required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Client ID</mat-label>
          <input matInput  formControlName="clientId" mat-raised-button required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Client Secret</mat-label>
          <input [type]="hideClientSecret ? 'password' : 'text'" matInput
            formControlName="clientSecret" mat-raised-button>
          <mat-icon matSuffix (click)="hideClientSecret = !hideClientSecret">
            {{hideClientSecret ? 'visibility' : 'visibility_off'}}
          </mat-icon>
        </mat-form-field>
        <mat-form-field class="w-full" *ngIf="uuid !== 'new'">
          <mat-label>Redirect URI</mat-label>
          <input matInput readonly  formControlName="redirectURI" mat-raised-button>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Profile URL</mat-label>
          <input matInput  formControlName="profileURL" mat-raised-button>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Token Endpoint</mat-label>
          <input matInput  formControlName="tokenURL" mat-raised-button required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Introspection Endpoint</mat-label>
          <input matInput  formControlName="introspectionURL" mat-raised-button>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Authorization Endpoint</mat-label>
          <input matInput  formControlName="authorizationURL" mat-raised-button
            required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Revocation Endpoint</mat-label>
          <input matInput  formControlName="revocationURL" mat-raised-button required>
        </mat-form-field>
        <div *ngFor="let scp of providerForm.get('scope')['controls']; let i = index;" formArrayName="scope">
          <div [formGroupName]="i">
            <mat-form-field class="w-1/2">
              <mat-label>Scope {{i+1}}</mat-label>
              <input matInput formControlName="scope" >
              <button mat-icon-button color="accent" matSuffix (click)="removeScope(i)">
                <mat-icon>close</mat-icon>
              </button>
            </mat-form-field>
          </div>
        </div>
        <button mat-button color="accent" (click)="addScope()">
          Add Scope <mat-icon>add</mat-icon>
        </button>
      </form>
    </mat-card-content>
    <mat-card-actions class="m-4 flex flex-row gap-2">
      <button (click)="updateProvider()" mat-flat-button color="primary" [disabled]="!providerForm.valid"
        *ngIf="name">Update</button>
      <button (click)="createProvider()" mat-flat-button color="primary" [disabled]="!providerForm.valid"
        *ngIf="!name">Create</button>
      <button (click)="delete()" mat-flat-button color="warn" *ngIf="uuid !== new">Delete</button>
    </mat-card-actions>
  </mat-card>
</div>
